// VTC6222-C4S API V1.0 2019/11/11
#define VTC6222_C4S_API extern "C" __declspec(dllimport)


struct PortLinkStatus
{
	unsigned char status[4];
};

struct PortLinkSpeed
{
	unsigned char speed[4];
};


VTC6222_C4S_API void Get_DLL_Version(int *pnMajorVersion, int *pnMinorVersion);
VTC6222_C4S_API bool Get_BIOS_Version(char *szBIOS_Ver, int nLen);
VTC6222_C4S_API bool Get_BIOS_Version_W(wchar_t *szBIOS_Ver, int nLen);

VTC6222_C4S_API int  Connect();
VTC6222_C4S_API void Disconnect();

// System command
VTC6222_C4S_API int  GetMCUVersion(int *pnMCUVersion);
VTC6222_C4S_API int  GetHWVersion(int *pnHWVersion);
VTC6222_C4S_API int  GetDTPVersion(int *pnDTPVersion);
VTC6222_C4S_API int  GetBLVersion(int *pnBLVersion);
VTC6222_C4S_API int  GetIgnitionStatus(int *pnIgnitionStatus);
VTC6222_C4S_API int  GetSupplyVoltage(int *pnSupplyVoltage);
VTC6222_C4S_API int  GetPowerType(int *pnPowerType);
VTC6222_C4S_API int  GetDelayTimeOption(int *pnPowerOff, int *pnPowerOn, int *pnDelayOffEnable, int *pnDelayOnEnable);
VTC6222_C4S_API int  GetStartupShutdownOption(int *pnStartupShutdownOption);
VTC6222_C4S_API int  GetAlarmTimer(int *pnHour, int *pnMin, int *pnSec);
VTC6222_C4S_API int  GetWWANStatus(int *pnWWAN_Enable, int *pnWWAN_Wakeup_Enable);
VTC6222_C4S_API int  GetWiFiStatus(int *pnWiFi_En1, int *pnWiFi_En2, int *pnWiFi_Pw1, int *pnWiFi_Pw2);
VTC6222_C4S_API int  GetBTStatus(int *pnBTStatus1, int *pnBTStatus2);
VTC6222_C4S_API int  GetGPSStatus(int *pnGPSStatus);
VTC6222_C4S_API int  GetUSBStatus(int *pnUSB2, int *pnUSB3);
VTC6222_C4S_API int  GetRTCStatus(int *pnRTCStatus);
VTC6222_C4S_API int  GetWatchdogConfig(int *pnWDT_Enable, int *pnTimeout);
VTC6222_C4S_API int  GetGsensorData(int nRegisterIndex, unsigned char *pbyGsensorData, int nGsensorDataLen);
VTC6222_C4S_API int  GetSIMCardStatus(int *pnSIMCard1);
VTC6222_C4S_API int  GetGPOStatus(int *pnGPO1, int *pnGPO2, int *pnGPO3, int *pnGPO4);
VTC6222_C4S_API int  GetGPIStatus(int *pnGPI1, int *pnGPI2, int *pnGPI3, int *pnGPI4);
VTC6222_C4S_API int  GetProgramLEDStatus(int *pnLED1, int *pnLED2, int *pnLED3, int *pnLED4);
VTC6222_C4S_API int  GetWakeOnLanStatus(int *pnWakeOnLanStatus);
VTC6222_C4S_API int  GetExternal12VStatus(int *pnExternal12VStatus);

VTC6222_C4S_API int  SetLoadDefault();
VTC6222_C4S_API int  SetRTCTimer(int nHour, int nMin, int nSec);
VTC6222_C4S_API int  SetDelayTimeOption(int nPowerOffDelayTime, int nPowerOffDelayTime_Enable, int nPowerOnDelayTime, int nPowerOnDelayTime_Enable);
VTC6222_C4S_API int  SetStartupShutdownOption(int nOption);
VTC6222_C4S_API int  SetAlarmTimer(int nHour, int nMin, int nSec);
VTC6222_C4S_API int  SetWWANControl(int nWWAN_Enable, int nWWAN_Wakeup_Enable);
VTC6222_C4S_API int  SetWiFiControl(int nWiFi_En1, int nWiFi_En2, int nWiFi_Pw1, int nWiFi_Pw2);
VTC6222_C4S_API int  SetBTControl(int nBT1, int nBT2);
VTC6222_C4S_API int  SetGPSControl(int nEnable);
VTC6222_C4S_API int  SetUSBControl(int nUSB2, int nUSB3);
VTC6222_C4S_API int  SetRTCControl(int nEnable);
VTC6222_C4S_API int  SetWatchdogControl(int nWDT_Enable);
VTC6222_C4S_API int  SetWatchdogTimer(int nWDT_TimeOut);
VTC6222_C4S_API int  SetFlashUpdate();
VTC6222_C4S_API int  SetGsensorData(int nRegIdx, unsigned char *pbyData, int nLen);
VTC6222_C4S_API int  SetSIMCardSelect(int nSIMCardSelect1);
VTC6222_C4S_API int  SetGPOControl(int nGPO1, int nGPO2, int nGPO3, int nGPO4);
VTC6222_C4S_API int  SetProgramLEDControl(int nLED1, int nLED2, int nLED3, int nLED4);
VTC6222_C4S_API int  SetWakeOnLanControl(int nEnable);
VTC6222_C4S_API int  SetExternal12VControl(int nEnable);

// PoE command
VTC6222_C4S_API int  GetPSEFWVersion(int *pnVer);
VTC6222_C4S_API int  GetPSETemperature(int *pnTemp);
VTC6222_C4S_API int  GetTotalConsumption(int *pnTotalConsumption);
VTC6222_C4S_API int  GetPOEStatus(unsigned char *pbyStatus);
VTC6222_C4S_API int  GetPortPowerConsumption(int nIndex, int *pnConsumption);
VTC6222_C4S_API int  GetAllPortLinkStatus(PortLinkStatus *pLinkStatus);

VTC6222_C4S_API int  SetPortPowerControl(int nIndex, int nPower);

VTC6222_C4S_API int  GetCHIPID(int *pnChipID);
VTC6222_C4S_API int  GetPortLinkStatus(unsigned char *pbyStatus);
VTC6222_C4S_API int  GetPortLinkSpeed(PortLinkSpeed *pLinkSpeed);


// ================================================================================================================================================
typedef void (__stdcall *EventSystemAlarm_CallBack)(unsigned char byAlarm);

VTC6222_C4S_API void RegisterSystemAlarmCallBackFunction(
	EventSystemAlarm_CallBack fnESA);
